##################################################################
#
# (C) Copyright 2002 Kapil Thangavelu <kvthan@wm.edu>
# All Rights Reserved
#
# This file is part of CMFDeployment.
#
# CMFDeployment is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CMFDeployment is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CMFDeployment; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##################################################################

"""

Author: kapil thangavelu <kvthan@wm.edu>
CVS: $Id: ContentURI.py,v 1.7 2002/10/18 19:30:34 kapil Exp $
License: GPL

Persistent URI Database

 allows for configuration of target path for uri normalization

 additional notes on normalization/resolution in URIResolver.py

"""
from Namespace import *
from Products.CMFCore import CMFCorePermissions
from URIResolver import URIResolver

class ContentURI(SimpleItem, URIResolver):

    meta_type = 'Content URI Resolver'

    manage_options = (

        { 'label':'Settings',
          'action':'content_uri_overview' },

        { 'label':'Policy',
          'action':'../manage_workspace'}
        )
    
    security = ClassSecurityInfo() 

    content_uri_overview = DTMLFile('ui/ContentURIOverview', globals())
    
    def __init__(self, id):
        self.id = id
        ContentURI.inheritedAttribute('__init__')(self)

    security.declarePrivate('clone')
    def clone(self, persistent=0):
        
        r = URIResolver()
        if persistent:
            r.__dict__.update(self.__dict__) # create a shared ref to the uri db
        else:
            r.target_path = self.target_path
        return r
    
    security.declareProtected(CMFCorePermissions.ManagePortal, 'edit')
    def editContentURI(self, target_path, REQUEST=None ):
        """ """

        self.target_path = target_path.strip()
        
        if REQUEST is not None:
            return REQUEST.RESPONSE.redirect('content_uri_overview')
        
    # protect some inherited methods
    security.declarePrivate('addResource')
    security.declarePrivate('resolve')
    
InitializeClass(ContentURI)
