##################################################################
#
# (C) Copyright 2002 Kapil Thangavelu <kvthan@wm.edu>
# All Rights Reserved
#
# This file is part of CMFDeployment.
#
# CMFDeployment is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CMFDeployment is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CMFDeployment; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##################################################################
"""
Purpose: Data object to track a deployed content object
Author: kapil thangavelu <kvthan@wm.edu>
License: GPL
Created: 8/10/2002
CVS: $Id: Descriptor.py,v 1.8 2002/10/18 19:30:34 kapil Exp $
"""

class ContentDescriptor:
    """
    a drop of water in a sieve
    """

    def __init__(self, content):
        self.content = content
        self.extension = None
        self.rendered  = None
        self.render_method = None
        self.binary = None
        self.ghost = None
        self.content_path = None
        self.source_path = None # relative path to content
        
    def getId(self):
        return self.content.getId()

    def getRendered(self):
        return self.rendered

    def getRenderMethod(self):
        return self.render_method 

    def getExtension(self):
        # this is a misnomer it reflects the entire
        # portion of the last path segment ie foo.txt
        return self.extension

    def getFileName(self):
        #return "%s%s"%(self.getId(),
        #               self.getExtension())
        return self.extension

    def getContent(self):
        return self.content

    def setRendered(self, rendered):
        self.rendered = rendered

    def isBinary(self):
        return not not self.binary

    def isGhost(self):
        return not not self.ghost

    def setGhost(self, flag):
        self.ghost = flag

    def setBinary(self, flag):
        self.binary = flag

    def setRenderMethod(self, method_name):
        self.render_method = method_name

    def setExtension(self, extension):
        self.extension = extension

    setFileName = setExtension

    def setContentPath(self, path):
        self.content_path = path

    def getContentPath(self):
        return self.content_path 

    def setSourcePath(self, path):
        self.source_path = path
        
    def getSourcePath(self):
        return self.source_path
